# -*- coding: mbcs -*-
# Do not delete the following import lines
from abaqus import *
from abaqusConstants import *
import __main__


import section
import regionToolset
import displayGroupMdbToolset as dgm
import part
import material
import assembly
import step
import interaction
import load
import mesh
import optimization
import job
import sketch
import visualization
import xyPlot
import displayGroupOdbToolset as dgo
import connectorBehavior

import math as m

jobname = 'Job-1'
t11 = 25
t12 = 10
t13 = 25
t2 = 360
t31 = 25
t32 = 10
t33 = 25
b1 = 115
b2 = 45
b3 = 115
b4 = 200
t4 = 800
ovre = 'CLT-C24-1'
steg = 'GL28c'
stegK = 'GL30c'
ende = 'GL30c'
nedre = 'CLT-C24-2'
storB = 'GL30c'
rho1 = 11.316666666666666
rho2 = 8.016666666666666
lengde = 10000
bredde = 2400
flate = 67808.2
punktlast = 0.014747















#Fikser punkter for plassering av punktlast kalt HC-1kN. 
lsteg = (bredde/2 - b1 - b2/2)/2 + b2/2
pl = m.sqrt(flate)/2 #Halve lengden av punktlast side
ph1 = (bredde/2 - (lsteg + b2/2) - b1)/2 + lsteg + b2/2 + pl  #Punktlasthjorne 1
ph2 = ph1 - 2*pl

#Fordelt last. 0.005 er tilsvarende 5kN/m^2
flatelast = 0.005


#Materialer brukt i endelig losning
mdb.models['Model-1'].Material(name='GL28c')
mdb.models['Model-1'].materials['GL28c'].Density(table=((4.3e-10, ), 
    ))
mdb.models['Model-1'].materials['GL28c'].Elastic(
    type=ENGINEERING_CONSTANTS, table=((12500.0, 300.0, 300.0, 0.39, 0.49, 
    0.64, 650.0, 650.0, 65.0), ))

mdb.models['Model-1'].Material(name='GL30c')
mdb.models['Model-1'].materials['GL30c'].Density(table=((4.3e-10, ), 
    ))
mdb.models['Model-1'].materials['GL30c'].Elastic(
    type=ENGINEERING_CONSTANTS, table=((13000.0, 300.0, 300.0, 0.39, 0.49, 
    0.64, 650.0, 650.0, 65.0), ))

mdb.models['Model-1'].Material(name='CLT-C24-1')
mdb.models['Model-1'].materials['CLT-C24-1'].Density(table=((rho1*1e-10, ), ))
mdb.models['Model-1'].materials['CLT-C24-1'].Elastic(type=ENGINEERING_CONSTANTS, 
    table=((11000.0, 370.0, 370.0, 0.11, 0.33, 0.33, 690.0, 690.0, 100.0), 
    ))

mdb.models['Model-1'].Material(name='CLT-C24-2')
mdb.models['Model-1'].materials['CLT-C24-2'].Density(table=((rho2*1e-10, ), ))
mdb.models['Model-1'].materials['CLT-C24-2'].Elastic(type=ENGINEERING_CONSTANTS, 
    table=((11000.0, 370.0, 370.0, 0.11, 0.33, 0.33, 690.0, 690.0, 100.0), 
    ))

#Flere materialer 
mdb.models['Model-1'].Material(name='Kerto-1')
mdb.models['Model-1'].materials['Kerto-1'].Density(table=((rho1*1e-10, ), 
    ))
mdb.models['Model-1'].materials['Kerto-1'].Elastic(
    type=ENGINEERING_CONSTANTS, table=((10500.0, 2000.0, 130.0, 0.11, 0.81, 
    0.07, 600.0, 120.0, 22.0), ))

mdb.models['Model-1'].Material(name='Kerto-2')
mdb.models['Model-1'].materials['Kerto-2'].Density(table=((rho2*1e-10, ), 
    ))
mdb.models['Model-1'].materials['Kerto-2'].Elastic(
    type=ENGINEERING_CONSTANTS, table=((10500.0, 2000.0, 130.0, 0.11, 0.81, 
    0.07, 600.0, 120.0, 22.0), ))

mdb.models['Model-1'].Material(name='GL28c-1')
mdb.models['Model-1'].materials['GL28c-1'].Density(table=((rho1*1e-10, ), 
    ))
mdb.models['Model-1'].materials['GL28c-1'].Elastic(
    type=ENGINEERING_CONSTANTS, table=((12500.0, 300.0, 300.0, 0.39, 0.49, 
    0.64, 650.0, 650.0, 65.0), ))

mdb.models['Model-1'].Material(name='GL28c-2')
mdb.models['Model-1'].materials['GL28c-2'].Density(table=((rho2*1e-10, ), 
    ))
mdb.models['Model-1'].materials['GL28c-2'].Elastic(
    type=ENGINEERING_CONSTANTS, table=((12500.0, 300.0, 300.0, 0.39, 0.49, 
    0.64, 650.0, 650.0, 65.0), ))

mdb.models['Model-1'].Material(name='I-Bjelke')
mdb.models['Model-1'].materials['I-Bjelke'].Density(table=((4.2e-10, ), 
    ))
mdb.models['Model-1'].materials['I-Bjelke'].Elastic(
    type=ENGINEERING_CONSTANTS, table=((13800.0, 2400.0, 2400.0, 0.39, 0.49, 
    0.64, 2100.0, 2100.0, 120.0), ))

mdb.models['Model-1'].Material(name='G-Bjelke')
mdb.models['Model-1'].materials['G-Bjelke'].Density(table=((4.11e-10, ), 
    ))
mdb.models['Model-1'].materials['G-Bjelke'].Elastic(
    type=ENGINEERING_CONSTANTS, table=((12000.0, 300.0, 300.0, 0.39, 0.49, 
    0.64, 300.0, 300.0, 35.0), ))

mdb.models['Model-1'].Material(name='K-Bjelke')
mdb.models['Model-1'].materials['K-Bjelke'].Density(table=((4.6e-10, ), 
    ))
mdb.models['Model-1'].materials['K-Bjelke'].Elastic(
    type=ENGINEERING_CONSTANTS, table=((11000.0, 370.0, 370.0, 0.39, 0.49, 
    0.64, 690.0, 690.0, 65.0), ))

mdb.models['Model-1'].Material(name='CLT-C30')
mdb.models['Model-1'].materials['CLT-C30'].Density(table=((4.6e-10, ), 
    ))
mdb.models['Model-1'].materials['CLT-C30'].Elastic(type=ENGINEERING_CONSTANTS, 
    table=((12000.0, 400.0, 400.0, 0.11, 0.33, 0.33, 750.0, 750.0, 100.0), 
    ))

mdb.models['Model-1'].Material(name='CLT-C24')
mdb.models['Model-1'].materials['CLT-C24'].Density(table=((4.2e-10, ), 
    ))
mdb.models['Model-1'].materials['CLT-C24'].Elastic(type=ENGINEERING_CONSTANTS, 
    table=((11000.0, 370.0, 370.0, 0.11, 0.33, 0.33, 690.0, 690.0, 100.0), 
    ))

mdb.models['Model-1'].Material(name='Kerto')
mdb.models['Model-1'].materials['Kerto'].Density(table=((5.1e-10, ), 
    ))
mdb.models['Model-1'].materials['Kerto'].Elastic(
    type=ENGINEERING_CONSTANTS, table=((10500.0, 2000.0, 130.0, 0.11, 0.81, 
    0.07, 600.0, 120.0, 22.0), ))





#Tegning av modell starter her (Parter)

#Ovre flens
s = mdb.models['Model-1'].ConstrainedSketch(name='__profile__', 
    sheetSize=lengde)
g, v, d, c = s.geometry, s.vertices, s.dimensions, s.constraints
s.setPrimaryObject(option=STANDALONE)
s.Line(point1=(-(lengde/2), t2/2), point2=((lengde/2), t2/2))
s.HorizontalConstraint(entity=g[2], addUndoState=False)
p = mdb.models['Model-1'].Part(name='P-OvreFlens', dimensionality=THREE_D, 
    type=DEFORMABLE_BODY)
p = mdb.models['Model-1'].parts['P-OvreFlens']
p.BaseShellExtrude(sketch=s, depth=bredde)

#Nedre flens
s1 = mdb.models['Model-1'].ConstrainedSketch(name='__profile__', 
    sheetSize=lengde)
g, v, d, c = s1.geometry, s1.vertices, s1.dimensions, s1.constraints
s1.setPrimaryObject(option=STANDALONE)
s1.Line(point1=(-(lengde/2), -t2/2), point2=((lengde/2), -t2/2))
s1.HorizontalConstraint(entity=g[2], addUndoState=False)
p = mdb.models['Model-1'].Part(name='P-NedreFlens', dimensionality=THREE_D, 
    type=DEFORMABLE_BODY)
p = mdb.models['Model-1'].parts['P-NedreFlens']
p.BaseShellExtrude(sketch=s1, depth=bredde)

#Endebjelke 1
s = mdb.models['Model-1'].ConstrainedSketch(name='__profile__', 
    sheetSize=lengde)
g, v, d, c = s.geometry, s.vertices, s.dimensions, s.constraints
s.setPrimaryObject(option=STANDALONE)
s.Line(point1=(-lengde/2, t2/2), point2=(-lengde/2, -t2/2))
s.VerticalConstraint(entity=g[2], addUndoState=False)
p = mdb.models['Model-1'].Part(name='P-Endebjelke1', dimensionality=THREE_D, 
    type=DEFORMABLE_BODY)
p = mdb.models['Model-1'].parts['P-Endebjelke1']
p.BaseShellExtrude(sketch=s, depth=bredde)

#Endebjelke 2
s1 = mdb.models['Model-1'].ConstrainedSketch(name='__profile__', 
    sheetSize=lengde)
g, v, d, c = s1.geometry, s1.vertices, s1.dimensions, s1.constraints
s1.setPrimaryObject(option=STANDALONE)
s1.Line(point1=(lengde/2, t2/2), point2=(lengde/2, -t2/2))
s1.VerticalConstraint(entity=g[2], addUndoState=False)
p = mdb.models['Model-1'].Part(name='P-Endebjelke2', dimensionality=THREE_D, 
    type=DEFORMABLE_BODY)
p = mdb.models['Model-1'].parts['P-Endebjelke2']
p.BaseShellExtrude(sketch=s1, depth=bredde)

#Steg 1
s = mdb.models['Model-1'].ConstrainedSketch(name='__profile__', 
    sheetSize=lengde)
g, v, d, c = s.geometry, s.vertices, s.dimensions, s.constraints
s.setPrimaryObject(option=STANDALONE)
s.rectangle(point1=(-lengde/2, t2/2), point2=(lengde/2, -t2/2))
p = mdb.models['Model-1'].Part(name='P-Steg1', dimensionality=THREE_D, 
    type=DEFORMABLE_BODY)
p = mdb.models['Model-1'].parts['P-Steg1']
p.BaseShell(sketch=s)

#Kopiere opp flere steg
p = mdb.models['Model-1'].Part(name='P-Steg2', 
    objectToCopy=mdb.models['Model-1'].parts['P-Steg1'])
p = mdb.models['Model-1'].Part(name='P-Steg3', 
    objectToCopy=mdb.models['Model-1'].parts['P-Steg2'])
p = mdb.models['Model-1'].Part(name='P-Steg4', 
    objectToCopy=mdb.models['Model-1'].parts['P-Steg3'])
p = mdb.models['Model-1'].Part(name='P-Steg5', 
    objectToCopy=mdb.models['Model-1'].parts['P-Steg4'])





#Partition face (For plassering av laster og parter)

#Ovre flens
p1 = mdb.models['Model-1'].parts['P-OvreFlens']
session.viewports['Viewport: 1'].setValues(displayedObject=p1)
p = mdb.models['Model-1'].parts['P-OvreFlens']
f, e, d1 = p.faces, p.edges, p.datums
t = p.MakeSketchTransform(sketchPlane=f[0], sketchUpEdge=e[3], 
    sketchPlaneSide=SIDE1, origin=(0.0, t2/2, bredde/2))
s1 = mdb.models['Model-1'].ConstrainedSketch(name='__profile__', 
    sheetSize=20000.0, gridSpacing=200.0, transform=t)
g, v, d, c = s1.geometry, s1.vertices, s1.dimensions, s1.constraints
s1.setPrimaryObject(option=SUPERIMPOSE)
p = mdb.models['Model-1'].parts['P-OvreFlens']
p.projectReferencesOntoSketch(sketch=s1, filter=COPLANAR_EDGES)

#Midtlinje
s1.Line(point1=(-(lengde/2), 0.0), point2=((lengde/2), 0.0))

#Steg 2 og 4
s1.Line(point1=(-(lengde/2), lsteg), point2=((lengde/2), lsteg))
s1.Line(point1=(-(lengde/2), -lsteg), point2=((lengde/2), -lsteg))

#Punktlast
s1.rectangle(point1=(-pl, ph1), point2=(pl, ph2))

#Avslutte denne partition
p = mdb.models['Model-1'].parts['P-OvreFlens']
f = p.faces
pickedFaces = f.getSequenceFromMask(mask=('[#1 ]', ), )
e1, d2 = p.edges, p.datums
p.PartitionFaceBySketch(sketchUpEdge=e1[3], faces=pickedFaces, sketch=s1)






#Orienteringer (For at trematerialene skal fungere som tiltenkt)
p = mdb.models['Model-1'].parts['P-NedreFlens']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = regionToolset.Region(faces=faces)
orientation=None
mdb.models['Model-1'].parts['P-NedreFlens'].MaterialOrientation(region=region, 
    orientationType=GLOBAL, axis=AXIS_3, 
    additionalRotationType=ROTATION_NONE, localCsys=None, fieldName='')

p = mdb.models['Model-1'].parts['P-OvreFlens']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1f ]', ), )
region = regionToolset.Region(faces=faces)
orientation=None
mdb.models['Model-1'].parts['P-OvreFlens'].MaterialOrientation(region=region, 
    orientationType=GLOBAL, axis=AXIS_3, 
    additionalRotationType=ROTATION_NONE, localCsys=None, fieldName='')

p = mdb.models['Model-1'].parts['P-Steg2']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = regionToolset.Region(faces=faces)
orientation=None
mdb.models['Model-1'].parts['P-Steg2'].MaterialOrientation(region=region, 
    orientationType=GLOBAL, axis=AXIS_3, 
    additionalRotationType=ROTATION_NONE, localCsys=None, fieldName='')

p = mdb.models['Model-1'].parts['P-Steg3']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = regionToolset.Region(faces=faces)
orientation=None
mdb.models['Model-1'].parts['P-Steg3'].MaterialOrientation(region=region, 
    orientationType=GLOBAL, axis=AXIS_3, 
    additionalRotationType=ROTATION_NONE, localCsys=None, fieldName='')

p = mdb.models['Model-1'].parts['P-Steg4']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = regionToolset.Region(faces=faces)
orientation=None
mdb.models['Model-1'].parts['P-Steg4'].MaterialOrientation(region=region, 
    orientationType=GLOBAL, axis=AXIS_3, 
    additionalRotationType=ROTATION_NONE, localCsys=None, fieldName='')

p = mdb.models['Model-1'].parts['P-Endebjelke2']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = regionToolset.Region(faces=faces)
orientation=None
mdb.models['Model-1'].parts['P-Endebjelke2'].MaterialOrientation(region=region, 
    orientationType=GLOBAL, axis=AXIS_2, 
    additionalRotationType=ROTATION_NONE, localCsys=None, fieldName='')

p = mdb.models['Model-1'].parts['P-Endebjelke1']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = regionToolset.Region(faces=faces)
orientation=None
mdb.models['Model-1'].parts['P-Endebjelke1'].MaterialOrientation(region=region, 
    orientationType=GLOBAL, axis=AXIS_2, 
    additionalRotationType=ROTATION_NONE, localCsys=None, fieldName='')

p = mdb.models['Model-1'].parts['P-Steg1']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = regionToolset.Region(faces=faces)
orientation=None
mdb.models['Model-1'].parts['P-Steg1'].MaterialOrientation(region=region, 
    orientationType=GLOBAL, axis=AXIS_3, 
    additionalRotationType=ROTATION_NONE, localCsys=None, fieldName='')

p = mdb.models['Model-1'].parts['P-Steg5']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = regionToolset.Region(faces=faces)
orientation=None
mdb.models['Model-1'].parts['P-Steg5'].MaterialOrientation(region=region, 
    orientationType=GLOBAL, axis=AXIS_3, 
    additionalRotationType=ROTATION_NONE, localCsys=None, fieldName='')






#Lage sections 

#CLT ovre
sectionLayer1 = section.SectionLayer(material=ovre, thickness=t11, 
    orientAngle=0.0, numIntPts=3, plyName='')
sectionLayer2 = section.SectionLayer(material=ovre, thickness=t12, 
    orientAngle=90.0, numIntPts=3, plyName='')
sectionLayer3 = section.SectionLayer(material=ovre, thickness=t13, 
    orientAngle=0.0, numIntPts=3, plyName='')
mdb.models['Model-1'].CompositeShellSection(name='S-Ovreflens-CLT', 
    preIntegrate=OFF, idealization=NO_IDEALIZATION, symmetric=False, 
    thicknessType=UNIFORM, poissonDefinition=DEFAULT, 
    thicknessModulus=None, temperature=GRADIENT, useDensity=OFF, 
    integrationRule=SIMPSON, layup=(sectionLayer1, sectionLayer2, 
    sectionLayer3, ))

#Evt Limtre (homogent) i ovre flens
mdb.models['Model-1'].HomogeneousShellSection(name='S-Ovreflens-Lim', 
    preIntegrate=OFF, material=ovre, thicknessType=UNIFORM, 
    thickness=(t11+t12+t13), thicknessField='', nodalThicknessField='', 
    idealization=NO_IDEALIZATION, poissonDefinition=DEFAULT, 
    thicknessModulus=None, temperature=GRADIENT, useDensity=OFF, 
    integrationRule=SIMPSON, numIntPts=5)


#CLT i nedre flens
sectionLayer1 = section.SectionLayer(material=nedre, thickness=t31, 
    orientAngle=0.0, numIntPts=3, plyName='')
sectionLayer2 = section.SectionLayer(material=nedre, thickness=t32, 
    orientAngle=90.0, numIntPts=3, plyName='')
sectionLayer3 = section.SectionLayer(material=nedre, thickness=t33, 
    orientAngle=0.0, numIntPts=3, plyName='')
mdb.models['Model-1'].CompositeShellSection(name='S-Nedreflens-CLT', 
    preIntegrate=OFF, idealization=NO_IDEALIZATION, symmetric=False, 
    thicknessType=UNIFORM, poissonDefinition=DEFAULT, 
    thicknessModulus=None, temperature=GRADIENT, useDensity=OFF, 
    integrationRule=SIMPSON, layup=(sectionLayer1, sectionLayer2, 
    sectionLayer3, ))

#Evt Limtre (homogent) i nedre
mdb.models['Model-1'].HomogeneousShellSection(name='S-Nedreflens-Lim', 
    preIntegrate=OFF, material=nedre, thicknessType=UNIFORM, 
    thickness=(t31+t32+t33), thicknessField='', nodalThicknessField='', 
    idealization=NO_IDEALIZATION, poissonDefinition=DEFAULT, 
    thicknessModulus=None, temperature=GRADIENT, useDensity=OFF, 
    integrationRule=SIMPSON, numIntPts=5)


#Steg
mdb.models['Model-1'].HomogeneousShellSection(name='S-Steg1', preIntegrate=OFF, 
    material=stegK, thicknessType=UNIFORM, thickness=b1, 
    thicknessField='', nodalThicknessField='', 
    idealization=NO_IDEALIZATION, poissonDefinition=DEFAULT, 
    thicknessModulus=None, temperature=GRADIENT, useDensity=OFF, 
    integrationRule=SIMPSON, numIntPts=5)

mdb.models['Model-1'].Section(name='S-Steg5', 
    objectToCopy=mdb.models['Model-1'].sections['S-Steg1'])

mdb.models['Model-1'].HomogeneousShellSection(name='S-Steg2', preIntegrate=OFF, 
    material=steg, thicknessType=UNIFORM, thickness=b2, 
    thicknessField='', nodalThicknessField='', 
    idealization=NO_IDEALIZATION, poissonDefinition=DEFAULT, 
    thicknessModulus=None, temperature=GRADIENT, useDensity=OFF, 
    integrationRule=SIMPSON, numIntPts=5)

mdb.models['Model-1'].Section(name='S-Steg3', 
    objectToCopy=mdb.models['Model-1'].sections['S-Steg2'])

mdb.models['Model-1'].Section(name='S-Steg4', 
    objectToCopy=mdb.models['Model-1'].sections['S-Steg3'])

#Endebjelker
mdb.models['Model-1'].HomogeneousShellSection(name='S-Endebjelke1', 
    preIntegrate=OFF, material=ende, thicknessType=UNIFORM, 
    thickness=b3, thicknessField='', nodalThicknessField='', 
    idealization=NO_IDEALIZATION, poissonDefinition=DEFAULT, 
    thicknessModulus=None, temperature=GRADIENT, useDensity=OFF, 
    integrationRule=SIMPSON, numIntPts=5)

mdb.models['Model-1'].Section(name='S-Endebjelke2', 
    objectToCopy=mdb.models['Model-1'].sections['S-Endebjelke1'])






# #Assign sections

# Her velges Homogent (Lim) eller CLT (CLT) i ovre flens
p = mdb.models['Model-1'].parts['P-OvreFlens']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1f ]', ), )
region = p.Set(faces=faces, name='Set-1')
p.SectionAssignment(region=region, sectionName='S-Ovreflens-CLT', offset=0.0,   
    offsetType=TOP_SURFACE, offsetField='', 
    thicknessAssignment=FROM_SECTION)

# #Her velges Homogent (Lim) eller CLT (CLT) i nedre flens
p = mdb.models['Model-1'].parts['P-NedreFlens']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = p.Set(faces=faces, name='Set-2')
p.SectionAssignment(region=region, sectionName='S-Nedreflens-CLT', offset=0.0,      
    offsetType=BOTTOM_SURFACE, offsetField='', 
    thicknessAssignment=FROM_SECTION)

p = mdb.models['Model-1'].parts['P-Steg1']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = p.Set(faces=faces, name='Set-3')
p = mdb.models['Model-1'].parts['P-Steg1']
p.SectionAssignment(region=region, sectionName='S-Steg1', offset=0.0, 
    offsetType=BOTTOM_SURFACE, offsetField='', 
    thicknessAssignment=FROM_SECTION)

p = mdb.models['Model-1'].parts['P-Steg2']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = p.Set(faces=faces, name='Set-4')
p.SectionAssignment(region=region, sectionName='S-Steg2', offset=0.0, 
    offsetType=MIDDLE_SURFACE, offsetField='', 
    thicknessAssignment=FROM_SECTION)

p = mdb.models['Model-1'].parts['P-Steg3']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = p.Set(faces=faces, name='Set-5')
p.SectionAssignment(region=region, sectionName='S-Steg3', offset=0.0, 
    offsetType=MIDDLE_SURFACE, offsetField='', 
    thicknessAssignment=FROM_SECTION)

p = mdb.models['Model-1'].parts['P-Steg4']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = p.Set(faces=faces, name='Set-6')
p.SectionAssignment(region=region, sectionName='S-Steg4', offset=0.0, 
    offsetType=MIDDLE_SURFACE, offsetField='', 
    thicknessAssignment=FROM_SECTION)

p = mdb.models['Model-1'].parts['P-Steg5']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = p.Set(faces=faces, name='Set-7')
p = mdb.models['Model-1'].parts['P-Steg5']
p.SectionAssignment(region=region, sectionName='S-Steg5', offset=0.0, 
    offsetType=TOP_SURFACE, offsetField='', 
    thicknessAssignment=FROM_SECTION)

p = mdb.models['Model-1'].parts['P-Endebjelke1']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = p.Set(faces=faces, name='Set-8')
p = mdb.models['Model-1'].parts['P-Endebjelke1']
p.SectionAssignment(region=region, sectionName='S-Endebjelke1', offset=0.0, 
    offsetType=BOTTOM_SURFACE, offsetField='', 
    thicknessAssignment=FROM_SECTION)

p = mdb.models['Model-1'].parts['P-Endebjelke2']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = p.Set(faces=faces, name='Set-9')
p = mdb.models['Model-1'].parts['P-Endebjelke2']
p.SectionAssignment(region=region, sectionName='S-Endebjelke2', offset=0.0, 
    offsetType=TOP_SURFACE, offsetField='', 
    thicknessAssignment=FROM_SECTION)





#Assembly
a = mdb.models['Model-1'].rootAssembly
session.viewports['Viewport: 1'].setValues(displayedObject=a)
session.viewports['Viewport: 1'].assemblyDisplay.setValues(
    optimizationTasks=OFF, geometricRestrictions=OFF, stopConditions=OFF)
a = mdb.models['Model-1'].rootAssembly
a.DatumCsysByDefault(CARTESIAN)
p = mdb.models['Model-1'].parts['P-OvreFlens']
a.Instance(name='P-OvreFlens-1', part=p, dependent=ON)
p = mdb.models['Model-1'].parts['P-NedreFlens']
a.Instance(name='P-NedreFlens-1', part=p, dependent=ON)
a = mdb.models['Model-1'].rootAssembly
#Sette inn steg og translate
p = mdb.models['Model-1'].parts['P-Steg5']
a.Instance(name='P-Steg5-1', part=p, dependent=ON)
a = mdb.models['Model-1'].rootAssembly
a.translate(instanceList=('P-Steg5-1', ), vector=(0.0, 0.0, bredde))
a = mdb.models['Model-1'].rootAssembly

p = mdb.models['Model-1'].parts['P-Steg4']
a.Instance(name='P-Steg4-1', part=p, dependent=ON)
a = mdb.models['Model-1'].rootAssembly
a.translate(instanceList=('P-Steg4-1', ), vector=(0.0, 0.0, (bredde/2 + lsteg)))
a = mdb.models['Model-1'].rootAssembly

p = mdb.models['Model-1'].parts['P-Steg3']
a.Instance(name='P-Steg3-1', part=p, dependent=ON)
a = mdb.models['Model-1'].rootAssembly
a.translate(instanceList=('P-Steg3-1', ), vector=(0.0, 0.0, bredde/2))
a = mdb.models['Model-1'].rootAssembly

p = mdb.models['Model-1'].parts['P-Steg2']
a.Instance(name='P-Steg2-1', part=p, dependent=ON)
a = mdb.models['Model-1'].rootAssembly
a.translate(instanceList=('P-Steg2-1', ), vector=(0.0, 0.0, (bredde/2 - lsteg)))
a = mdb.models['Model-1'].rootAssembly

p = mdb.models['Model-1'].parts['P-Steg1']
a.Instance(name='P-Steg1-1', part=p, dependent=ON)
a = mdb.models['Model-1'].rootAssembly


p = mdb.models['Model-1'].parts['P-Endebjelke1']
a.Instance(name='P-Endebjelke1-1', part=p, dependent=ON)
a = mdb.models['Model-1'].rootAssembly

p = mdb.models['Model-1'].parts['P-Endebjelke2']
a.Instance(name='P-Endebjelke2-1', part=p, dependent=ON)
a = mdb.models['Model-1'].rootAssembly

#Merge assembly
a.InstanceFromBooleanMerge(name='P-Sammensatt1', instances=(
    a.instances['P-Steg5-1'], a.instances['P-OvreFlens-1'], 
    a.instances['P-NedreFlens-1'], a.instances['P-Steg4-1'], 
    a.instances['P-Steg3-1'], a.instances['P-Steg2-1'], 
    a.instances['P-Steg1-1'], a.instances['P-Endebjelke1-1'], 
    a.instances['P-Endebjelke2-1'], ), originalInstances=SUPPRESS, 
    domain=GEOMETRY)
p = mdb.models['Model-1'].parts['P-Sammensatt1']
session.viewports['Viewport: 1'].setValues(displayedObject=p)

session.viewports['Viewport: 1'].view.setValues(nearPlane=3059.89, 
    farPlane=11766.9, cameraPosition=(4048.06, 2710.08, 6796.39), 
    cameraUpVector=(-0.218879, 0.923304, -0.315598), cameraTarget=(-296.56, 
    -548.373, 276.67))




#Fikse offset for material tykkelsene
p1 = mdb.models['Model-1'].parts['P-Sammensatt1']
session.viewports['Viewport: 1'].setValues(displayedObject=p1)
mdb.models['Model-1'].parts['P-Sammensatt1'].sectionAssignments[0].setValues(
    offsetType=TOP_SURFACE, offsetField='', offset=0.0)

p1 = mdb.models['Model-1'].parts['P-Sammensatt1']
session.viewports['Viewport: 1'].setValues(displayedObject=p1)
mdb.models['Model-1'].parts['P-Sammensatt1'].sectionAssignments[6].setValues(
    offsetType=BOTTOM_SURFACE, offsetField='', offset=0.0)

p1 = mdb.models['Model-1'].parts['P-Sammensatt1']
session.viewports['Viewport: 1'].setValues(displayedObject=p1)
mdb.models['Model-1'].parts['P-Sammensatt1'].sectionAssignments[1].setValues(
    offsetType=TOP_SURFACE, offsetField='', offset=0.0)

p1 = mdb.models['Model-1'].parts['P-Sammensatt1']
session.viewports['Viewport: 1'].setValues(displayedObject=p1)
mdb.models['Model-1'].parts['P-Sammensatt1'].sectionAssignments[2].setValues(
    offsetType=BOTTOM_SURFACE, offsetField='', offset=0.0)

p1 = mdb.models['Model-1'].parts['P-Sammensatt1']
session.viewports['Viewport: 1'].setValues(displayedObject=p1)
mdb.models['Model-1'].parts['P-Sammensatt1'].sectionAssignments[3].setValues(
    offsetType=MIDDLE_SURFACE, offsetField='', offset=0.0)

p1 = mdb.models['Model-1'].parts['P-Sammensatt1']
session.viewports['Viewport: 1'].setValues(displayedObject=p1)
mdb.models['Model-1'].parts['P-Sammensatt1'].sectionAssignments[4].setValues(
    offsetType=MIDDLE_SURFACE, offsetField='', offset=0.0)

p1 = mdb.models['Model-1'].parts['P-Sammensatt1']
session.viewports['Viewport: 1'].setValues(displayedObject=p1)
mdb.models['Model-1'].parts['P-Sammensatt1'].sectionAssignments[5].setValues(
    offsetType=MIDDLE_SURFACE, offsetField='', offset=0.0)

p1 = mdb.models['Model-1'].parts['P-Sammensatt1']
session.viewports['Viewport: 1'].setValues(displayedObject=p1)
mdb.models['Model-1'].parts['P-Sammensatt1'].sectionAssignments[7].setValues(
    offsetType=TOP_SURFACE, offsetField='', offset=0.0)

p1 = mdb.models['Model-1'].parts['P-Sammensatt1']
session.viewports['Viewport: 1'].setValues(displayedObject=p1)
mdb.models['Model-1'].parts['P-Sammensatt1'].sectionAssignments[8].setValues(
    offsetType=BOTTOM_SURFACE, offsetField='', offset=0.0)




#Lage stor bjelkene
#Storbjelke1
s = mdb.models['Model-1'].ConstrainedSketch(name='__profile__', 
    sheetSize=lengde)
g, v, d, c = s.geometry, s.vertices, s.dimensions, s.constraints
s.setPrimaryObject(option=STANDALONE)
s.Line(point1=(-lengde/2, t2/2), point2=(-lengde/2, -(t4 - t2/2)))
s.VerticalConstraint(entity=g[2], addUndoState=False)
p = mdb.models['Model-1'].Part(name='P-Storbjelke1', dimensionality=THREE_D, 
    type=DEFORMABLE_BODY)
p = mdb.models['Model-1'].parts['P-Storbjelke1']
p.BaseShellExtrude(sketch=s, depth=(bredde*2 + 20))

#Storbjelke2
s1 = mdb.models['Model-1'].ConstrainedSketch(name='__profile__', 
    sheetSize=lengde)
g, v, d, c = s1.geometry, s1.vertices, s1.dimensions, s1.constraints
s1.setPrimaryObject(option=STANDALONE)
s1.Line(point1=(lengde/2, t2/2), point2=(lengde/2, -(t4 - t2/2)))
s1.VerticalConstraint(entity=g[2], addUndoState=False)
p = mdb.models['Model-1'].Part(name='P-Storbjelke2', dimensionality=THREE_D, 
    type=DEFORMABLE_BODY)
p = mdb.models['Model-1'].parts['P-Storbjelke2']
p.BaseShellExtrude(sketch=s1, depth=(bredde*2 + 20))

#Section storbjelke
mdb.models['Model-1'].HomogeneousShellSection(name='S-Storbjelke1', 
    preIntegrate=OFF, material=storB, thicknessType=UNIFORM, 
    thickness=b4, thicknessField='', nodalThicknessField='', 
    idealization=NO_IDEALIZATION, poissonDefinition=DEFAULT, 
    thicknessModulus=None, temperature=GRADIENT, useDensity=OFF, 
    integrationRule=SIMPSON, numIntPts=5)

mdb.models['Model-1'].Section(name='S-Storbjelke2', 
    objectToCopy=mdb.models['Model-1'].sections['S-Storbjelke1'])

#Assigne storbjelke
p = mdb.models['Model-1'].parts['P-Storbjelke1']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = p.Set(faces=faces, name='Set-8')
p = mdb.models['Model-1'].parts['P-Storbjelke1']
p.SectionAssignment(region=region, sectionName='S-Storbjelke1', offset=0.0, 
    offsetType=BOTTOM_SURFACE, offsetField='', 
    thicknessAssignment=FROM_SECTION)

p = mdb.models['Model-1'].parts['P-Storbjelke2']
f = p.faces
faces = f.getSequenceFromMask(mask=('[#1 ]', ), )
region = p.Set(faces=faces, name='Set-9')
p = mdb.models['Model-1'].parts['P-Storbjelke2']
p.SectionAssignment(region=region, sectionName='S-Storbjelke2', offset=0.0, 
    offsetType=TOP_SURFACE, offsetField='', 
    thicknessAssignment=FROM_SECTION)





#Assembly nr 2
a = mdb.models['Model-1'].rootAssembly
p = mdb.models['Model-1'].parts['P-Sammensatt1']
a.Instance(name='P-Sammensatt1-2', part=p, dependent=ON)
a = mdb.models['Model-1'].rootAssembly
a.translate(instanceList=('P-Sammensatt1-2', ), vector=(0.0, 0.0, bredde))
a = mdb.models['Model-1'].rootAssembly

p = mdb.models['Model-1'].parts['P-Storbjelke1']
a.Instance(name='P-Storbjelke1-1', part=p, dependent=ON)
a = mdb.models['Model-1'].rootAssembly
a.translate(instanceList=('P-Storbjelke1-1', ), vector=(0.0, 0.0, -10))
a = mdb.models['Model-1'].rootAssembly

p = mdb.models['Model-1'].parts['P-Storbjelke2']
a.Instance(name='P-Storbjelke2-1', part=p, dependent=ON)
a = mdb.models['Model-1'].rootAssembly
a.translate(instanceList=('P-Storbjelke2-1', ), vector=(0.0, 0.0, -10))
a = mdb.models['Model-1'].rootAssembly





#Lage steps
a = mdb.models['Model-1'].rootAssembly
session.viewports['Viewport: 1'].setValues(displayedObject=a)
session.viewports['Viewport: 1'].assemblyDisplay.setValues(
    adaptiveMeshConstraints=ON)
mdb.models['Model-1'].StaticStep(name='Egenlast', previous='Initial')
session.viewports['Viewport: 1'].assemblyDisplay.setValues(step='Egenlast')
mdb.models['Model-1'].StaticStep(name='HC-1kN', previous='Egenlast')
session.viewports['Viewport: 1'].assemblyDisplay.setValues(step='HC-1kN')
mdb.models['Model-1'].StaticStep(name='Flatelast', previous='HC-1kN')
session.viewports['Viewport: 1'].assemblyDisplay.setValues(step='Flatelast')
mdb.models['Model-1'].FrequencyStep(name='Egenfrekvens', previous='Flatelast', 
    maxEigen=40.0, numEigen=5)
session.viewports['Viewport: 1'].assemblyDisplay.setValues(step='Egenfrekvens')
session.viewports['Viewport: 1'].assemblyDisplay.setValues(loads=ON, bcs=ON, 
    predefinedFields=ON, connectors=ON, adaptiveMeshConstraints=OFF)


mdb.models['Model-1'].fieldOutputRequests['F-Output-1'].setValuesInStep(
    stepName='HC-1kN', variables=('S', 'PE', 'PEEQ', 'PEMAG', 'LE', 'U', 'UT', 
    'RF', 'CF', 'CSTRESS', 'CDISP'))






# #Lage ties
#Ties mellom dekker og storbjelke
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-2'].faces
faces1 = f1.getSequenceFromMask(mask=('[#3ffef3 ]', ), )
f2 = a.instances['P-Storbjelke1-1'].faces
faces2 = f2.getSequenceFromMask(mask=('[#1 ]', ), )
f3 = a.instances['P-Storbjelke2-1'].faces
faces3 = f3.getSequenceFromMask(mask=('[#1 ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1+faces2+faces3)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-1'].faces
faces1 = f1.getSequenceFromMask(mask=('[#200000 ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-2'].faces
faces1 = f1.getSequenceFromMask(mask=('[#c ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-1'].faces
faces1 = f1.getSequenceFromMask(mask=('[#8001 ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
a = mdb.models['Model-1'].rootAssembly
s1 = a.instances['P-Storbjelke2-1'].faces
side1Faces1 = s1.getSequenceFromMask(mask=('[#1 ]', ), )
region1=a.Surface(side1Faces=side1Faces1, name='m_Surf-1')
a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Sammensatt1-2'].edges
edges1 = e1.getSequenceFromMask(mask=('[#800 ]', ), )
region2=a.Set(edges=edges1, name='s_Set-1')
mdb.models['Model-1'].Tie(name='Tie-1', master=region1, slave=region2, 
    positionToleranceMethod=COMPUTED, adjust=ON, tieRotations=ON, 
    thickness=ON)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
leaf = dgm.Leaf(leafType=DEFAULT_MODEL)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.replace(
    leaf=leaf)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-1'].faces
faces1 = f1.getSequenceFromMask(mask=('[#1fffff ]', ), )
f2 = a.instances['P-Storbjelke1-1'].faces
faces2 = f2.getSequenceFromMask(mask=('[#1 ]', ), )
f3 = a.instances['P-Storbjelke2-1'].faces
faces3 = f3.getSequenceFromMask(mask=('[#1 ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1+faces2+faces3)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-1'].faces
faces1 = f1.getSequenceFromMask(mask=('[#200000 ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-2'].faces
faces1 = f1.getSequenceFromMask(mask=('[#3ffe0c ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
a = mdb.models['Model-1'].rootAssembly
s1 = a.instances['P-Storbjelke2-1'].faces
side1Faces1 = s1.getSequenceFromMask(mask=('[#1 ]', ), )
region1=a.Surface(side1Faces=side1Faces1, name='m_Surf-2')
a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Sammensatt1-2'].edges
edges1 = e1.getSequenceFromMask(mask=('[#800 ]', ), )
region2=a.Set(edges=edges1, name='s_Set-2')
mdb.models['Model-1'].Tie(name='Tie-2', master=region1, slave=region2, 
    positionToleranceMethod=COMPUTED, adjust=ON, tieRotations=ON, 
    thickness=ON)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
leaf = dgm.Leaf(leafType=DEFAULT_MODEL)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.replace(
    leaf=leaf)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-2'].faces
faces1 = f1.getSequenceFromMask(mask=('[#3ffeff ]', ), )
f2 = a.instances['P-Storbjelke1-1'].faces
faces2 = f2.getSequenceFromMask(mask=('[#1 ]', ), )
f3 = a.instances['P-Storbjelke2-1'].faces
faces3 = f3.getSequenceFromMask(mask=('[#1 ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1+faces2+faces3)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-1'].faces
faces1 = f1.getSequenceFromMask(mask=('[#200000 ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-1'].faces
faces1 = f1.getSequenceFromMask(mask=('[#17f837 ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
a = mdb.models['Model-1'].rootAssembly
s1 = a.instances['P-Storbjelke1-1'].faces
side2Faces1 = s1.getSequenceFromMask(mask=('[#1 ]', ), )
region1=a.Surface(side2Faces=side2Faces1, name='m_Surf-3')
a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Sammensatt1-2'].edges
edges1 = e1.getSequenceFromMask(mask=('[#1000000 ]', ), )
region2=a.Set(edges=edges1, name='s_Set-3')
mdb.models['Model-1'].Tie(name='Tie-3', master=region1, slave=region2, 
    positionToleranceMethod=COMPUTED, adjust=ON, tieRotations=ON, 
    thickness=ON)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
leaf = dgm.Leaf(leafType=DEFAULT_MODEL)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.replace(
    leaf=leaf)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-1'].faces
faces1 = f1.getSequenceFromMask(mask=('[#1fffff ]', ), )
f2 = a.instances['P-Storbjelke1-1'].faces
faces2 = f2.getSequenceFromMask(mask=('[#1 ]', ), )
f3 = a.instances['P-Storbjelke2-1'].faces
faces3 = f3.getSequenceFromMask(mask=('[#1 ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1+faces2+faces3)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-2'].faces
faces1 = f1.getSequenceFromMask(mask=('[#100 ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-2'].faces
faces1 = f1.getSequenceFromMask(mask=('[#1dfecf ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
a = mdb.models['Model-1'].rootAssembly
s1 = a.instances['P-Storbjelke1-1'].faces
side2Faces1 = s1.getSequenceFromMask(mask=('[#1 ]', ), )
region1=a.Surface(side2Faces=side2Faces1, name='m_Surf-4')
a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Sammensatt1-1'].edges
edges1 = e1.getSequenceFromMask(mask=('[#8000 ]', ), )
region2=a.Set(edges=edges1, name='s_Set-4')
mdb.models['Model-1'].Tie(name='Tie-4', master=region1, slave=region2, 
    positionToleranceMethod=COMPUTED, adjust=ON, tieRotations=ON, 
    thickness=ON)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
leaf = dgm.Leaf(leafType=DEFAULT_MODEL)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.replace(
    leaf=leaf)

session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Sammensatt1-2'].edges
edges1 = e1.getSequenceFromMask(mask=('[#800 ]', ), )
leaf = dgm.LeafFromGeometry(edgeSeq=edges1)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Sammensatt1-2'].edges
edges1 = e1.getSequenceFromMask(mask=('[#800 ]', ), )
leaf = dgm.LeafFromGeometry(edgeSeq=edges1)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Sammensatt1-2'].edges
edges1 = e1.getSequenceFromMask(mask=('[#800 ]', ), )
region1=a.Set(edges=edges1, name='m_Set-10')
a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Sammensatt1-1'].edges
edges1 = e1.getSequenceFromMask(mask=('[#4 ]', ), )
region2=a.Set(edges=edges1, name='s_Set-10')
mdb.models['Model-1'].Tie(name='Tie-6', master=region1, slave=region2, 
    positionToleranceMethod=COMPUTED, adjust=ON, tieRotations=ON, 
    thickness=ON)

#Ties mellom dekkenes flenser
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-2'].faces
faces1 = f1.getSequenceFromMask(mask=('[#3ffeff ]', ), )
f2 = a.instances['P-Storbjelke1-1'].faces
faces2 = f2.getSequenceFromMask(mask=('[#1 ]', ), )
f3 = a.instances['P-Storbjelke2-1'].faces
faces3 = f3.getSequenceFromMask(mask=('[#1 ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1+faces2+faces3)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-1'].faces
faces1 = f1.getSequenceFromMask(mask=('[#1fffff ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-1'].faces
faces1 = f1.getSequenceFromMask(mask=('[#200000 ]', ), )
leaf = dgm.LeafFromGeometry(faceSeq=faces1)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Sammensatt1-1'].edges
edges1 = e1.getSequenceFromMask(mask=('[#0 #8 ]', ), )
region1=a.Set(edges=edges1, name='m_Set-11')
a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Sammensatt1-2'].edges
edges1 = e1.getSequenceFromMask(mask=('[#4000000 ]', ), )
region2=a.Set(edges=edges1, name='s_Set-11')
mdb.models['Model-1'].Tie(name='Tie-7', master=region1, slave=region2, 
    positionToleranceMethod=COMPUTED, adjust=ON, tieRotations=ON, 
    thickness=ON)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.undoLast()
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.undoLast()
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.redoLast()
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Sammensatt1-1'].edges
edges1 = e1.getSequenceFromMask(mask=('[#0 #4 ]', ), )
leaf = dgm.LeafFromGeometry(edgeSeq=edges1)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.remove(leaf=leaf)
a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Sammensatt1-1'].edges
edges1 = e1.getSequenceFromMask(mask=('[#0 #4 ]', ), )
region1=a.Set(edges=edges1, name='m_Set-13')
a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Sammensatt1-2'].edges
edges1 = e1.getSequenceFromMask(mask=('[#8000000 ]', ), )
region2=a.Set(edges=edges1, name='s_Set-13')
mdb.models['Model-1'].Tie(name='Tie-8', master=region1, slave=region2, 
    positionToleranceMethod=COMPUTED, adjust=ON, tieRotations=ON, 
    thickness=ON)
session.linkedViewportCommands.setValues(_highlightLinkedViewports=False)
leaf = dgm.Leaf(leafType=DEFAULT_MODEL)
session.viewports['Viewport: 1'].assemblyDisplay.displayGroup.replace(
    leaf=leaf)




# #Opplager
session.viewports['Viewport: 1'].assemblyDisplay.setValues(step='Initial')
a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Storbjelke2-1'].edges
edges1 = e1.getSequenceFromMask(mask=('[#5 ]', ), )
e2 = a.instances['P-Sammensatt1-1'].edges
edges2 = e2.getSequenceFromMask(mask=('[#800 ]', ), )
e3 = a.instances['P-Sammensatt1-2'].edges
edges3 = e3.getSequenceFromMask(mask=('[#4 ]', ), )
region = a.Set(edges=edges1+edges2+edges3, name='Set-5')
mdb.models['Model-1'].DisplacementBC(name='BC-2', createStepName='Initial', 
    region=region, u1=SET, u2=SET, u3=SET, ur1=UNSET, ur2=UNSET, ur3=UNSET, 
    amplitude=UNSET, distributionType=UNIFORM, fieldName='', 
    localCsys=None)

a = mdb.models['Model-1'].rootAssembly
e1 = a.instances['P-Storbjelke1-1'].edges
edges1 = e1.getSequenceFromMask(mask=('[#5 ]', ), )
e2 = a.instances['P-Sammensatt1-1'].edges
edges2 = e2.getSequenceFromMask(mask=('[#1000000 ]', ), )
e3 = a.instances['P-Sammensatt1-2'].edges
edges3 = e3.getSequenceFromMask(mask=('[#8000 ]', ), )
region = a.Set(edges=edges1+edges2+edges3, name='Set-6')
mdb.models['Model-1'].DisplacementBC(name='BC-3', createStepName='Initial', 
    region=region, u1=SET, u2=SET, u3=SET, ur1=UNSET, ur2=UNSET, ur3=UNSET, 
    amplitude=UNSET, distributionType=UNIFORM, fieldName='', 
    localCsys=None)





#Laster
mdb.models['Model-1'].Gravity(name='Egenlast', createStepName='Egenlast', 
    comp2=-9810.0, distributionType=UNIFORM, field='')

session.viewports['Viewport: 1'].assemblyDisplay.setValues(step='HC-1kN')
a = mdb.models['Model-1'].rootAssembly
s1 = a.instances['P-Sammensatt1-1'].faces                                       #For aa sette lasten paa andre dekket byttes det til 'P-Sammensatt1-1' eller 'P-Sammensatt1-2'
side2Faces1 = s1.getSequenceFromMask(mask=('[#20000 ]', ), )
region = a.Surface(side2Faces=side2Faces1, name='Surf-5')
mdb.models['Model-1'].Pressure(name='Punktlast-2-dekker', createStepName='HC-1kN', 
    region=region, distributionType=UNIFORM, field='', magnitude=punktlast, 
    amplitude=UNSET)

session.viewports['Viewport: 1'].assemblyDisplay.setValues(step='Flatelast')
a = mdb.models['Model-1'].rootAssembly
s1 = a.instances['P-Sammensatt1-2'].faces
side2Faces1 = s1.getSequenceFromMask(mask=('[#1f0000 ]', ), )
s2 = a.instances['P-Sammensatt1-1'].faces
side2Faces2 = s2.getSequenceFromMask(mask=('[#1f0000 ]', ), )
region = a.Surface(side2Faces=side2Faces1+side2Faces2, name='Surf-6')
mdb.models['Model-1'].Pressure(name='Flatelast', createStepName='Flatelast', 
    region=region, distributionType=UNIFORM, field='', magnitude=flatelast, 
    amplitude=UNSET)

#Deaktivere punktlast i andre steps
mdb.models['Model-1'].loads['Punktlast-2-dekker'].deactivate('Flatelast')

#Dele opp med ekstra step for aa faa ut tiktig nedboyning for flatelast
mdb.models['Model-1'].StaticStep(name='Initial2', previous='HC-1kN')
session.viewports['Viewport: 1'].assemblyDisplay.setValues(step='Initial2')
session.viewports['Viewport: 1'].assemblyDisplay.setValues(loads=ON, bcs=ON, 
    predefinedFields=ON, connectors=ON, adaptiveMeshConstraints=OFF)
mdb.models['Model-1'].loads['Egenlast'].deactivate('Initial2')
mdb.models['Model-1'].loads['Punktlast-2-dekker'].deactivate('Initial2')
session.viewports['Viewport: 1'].assemblyDisplay.setValues(step='Flatelast')
mdb.models['Model-1'].Gravity(name='Egenlast2', createStepName='Flatelast', 
    comp2=-9810.0, distributionType=UNIFORM, field='')




#Mesh
#make independant
session.viewports['Viewport: 1'].assemblyDisplay.setValues(loads=OFF, bcs=OFF, 
    predefinedFields=OFF, connectors=OFF)
a1 = mdb.models['Model-1'].rootAssembly
a1.makeIndependent(instances=(a1.instances['P-Sammensatt1-1'], 
    a1.instances['P-Sammensatt1-2'], ))
a1 = mdb.models['Model-1'].rootAssembly
a1.makeIndependent(instances=(a1.instances['P-Storbjelke1-1'], ))
a1 = mdb.models['Model-1'].rootAssembly
a1.makeIndependent(instances=(a1.instances['P-Storbjelke2-1'], ))

#Seed osv
a = mdb.models['Model-1'].rootAssembly
partInstances =(a.instances['P-Sammensatt1-1'], a.instances['P-Sammensatt1-2'], 
    a.instances['P-Storbjelke1-1'], a.instances['P-Storbjelke2-1'], )
a.seedPartInstance(regions=partInstances, size=50.0, deviationFactor=0.1, 
    minSizeFactor=0.1)
elemType1 = mesh.ElemType(elemCode=S4, elemLibrary=STANDARD, 
    secondOrderAccuracy=OFF)
elemType2 = mesh.ElemType(elemCode=S3, elemLibrary=STANDARD)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-1'].faces
faces1 = f1.getSequenceFromMask(mask=('[#3fffff ]', ), )
f2 = a.instances['P-Sammensatt1-2'].faces
faces2 = f2.getSequenceFromMask(mask=('[#3fffff ]', ), )
f3 = a.instances['P-Storbjelke1-1'].faces
faces3 = f3.getSequenceFromMask(mask=('[#1 ]', ), )
f4 = a.instances['P-Storbjelke2-1'].faces
faces4 = f4.getSequenceFromMask(mask=('[#1 ]', ), )
pickedRegions =((faces1+faces2+faces3+faces4), )
a.setElementType(regions=pickedRegions, elemTypes=(elemType1, elemType2))
a = mdb.models['Model-1'].rootAssembly
partInstances =(a.instances['P-Sammensatt1-1'], a.instances['P-Sammensatt1-2'], 
    a.instances['P-Storbjelke1-1'], a.instances['P-Storbjelke2-1'], )
a.generateMesh(regions=partInstances)

#Fikse mesh rundt punktlast
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-2'].faces
faces1 = f1.getSequenceFromMask(mask=('[#10000 ]', ), )
f2 = a.instances['P-Sammensatt1-1'].faces
faces2 = f2.getSequenceFromMask(mask=('[#10000 ]', ), )
pickedRegions = faces1+faces2
a.deleteMesh(regions=pickedRegions)
a = mdb.models['Model-1'].rootAssembly
f1 = a.instances['P-Sammensatt1-2'].faces
faces1 = f1.getSequenceFromMask(mask=('[#10000 ]', ), )
f2 = a.instances['P-Sammensatt1-1'].faces
faces2 = f2.getSequenceFromMask(mask=('[#10000 ]', ), )
pickedRegions = faces1+faces2
a.setMeshControls(regions=pickedRegions, algorithm=MEDIAL_AXIS)
a = mdb.models['Model-1'].rootAssembly
partInstances =(a.instances['P-Sammensatt1-2'], a.instances['P-Sammensatt1-1'], 
    )
a.generateMesh(regions=partInstances)



#Sette fint view
session.viewports['Viewport: 1'].view.setValues(nearPlane=14340.5, 
    farPlane=23176.1, width=9990.69, height=5801.14, cameraPosition=(-8372.03, 
    6387.36, 15928), cameraUpVector=(0.15547, 0.806343, -0.570649), 
    cameraTarget=(-2661.86, 423.745, -3012.28), viewOffsetX=2777.31, 
    viewOffsetY=-739.511)

#Create job
mdb.Job(name=jobname, model='Model-1', description='', type=ANALYSIS, 
    atTime=None, waitMinutes=0, waitHours=0, queue=None, memory=90, 
    memoryUnits=PERCENTAGE, getMemoryFromAnalysis=True, 
    explicitPrecision=SINGLE, nodalOutputPrecision=SINGLE, echoPrint=OFF, 
    modelPrint=OFF, contactPrint=OFF, historyPrint=OFF, userSubroutine='', 
    scratch='', resultsFormat=ODB, multiprocessingMode=DEFAULT, numCpus=4, 
    numDomains=4, numGPUs=2)

#Run job
mdb.jobs[jobname].submit(consistencyChecking=OFF)